; File:     Combo7.asm
; by:       Rui Loureiro
;===============================================================================================
; WM_NOTIFY : lParam points to NMHDR
; You can create a ComboBoxEx control by using the CreateWindowEx 
; function and specifying WC_COMBOBOXEX as the window class
; A ComboBoxEx control must be initialized by 
; calling the InitCommonControlsEx function, specifying ICC_USEREX_CLASSES 
;===============================================================================================
;                           Ficheiros inc / GLB
;-----------------------------------------------------------------------------------------------

                            include Combo7.inc

COMBO_STYLE     equ WS_CHILD+WS_BORDER+WS_VISIBLE+WS_TABSTOP+WS_VSCROLL+CBS_HASSTRINGS+CBS_DROPDOWN
COMBO_STYLE2    equ WS_CHILD+WS_BORDER+WS_VISIBLE+WS_TABSTOP+WS_VSCROLL+CBS_HASSTRINGS+CBS_DROPDOWN+CBS_OWNERDRAWFIXED 

COMBOBOX    macro x, y, dx, dy, ID
            invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr CN_ComboBoxEx, NULL, COMBO_STYLE,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox, eax
ENDM
SETUPCOMBO      macro   Tbl
                push    esi
                mov     esi, offset Tbl
                mov     ecx, dword ptr [esi - 4]
                xor     ebx, ebx
@@:             push    ecx

                mov     eax, CBEIF_TEXT
                ;mov     _cbex.mask, eax         ;CBEIF_TEXT
                mov     _cbex.iItem, ebx
                mov     eax, [esi + ebx*4]
                mov     _cbex.pszText, eax

                invoke  SendMessage, _hComboBox, CBEM_INSERTITEM, 0, addr _cbex
                pop     ecx
                add     ebx, 1
                sub     ecx, 1
                jnz     short @B
                
                ;invoke SendMessage, _hComboBox, CB_SETCURSEL, 0 ,0
                mov    _hComboItem, 0
                pop     esi
ENDM

DIALOGBOX         MACRO  Name, Proc
    invoke  DialogBoxParam, _hInstance, addr Name, _hWnd, addr Proc, 0 
ENDM
;===============================================================================================
;                           Constantes e Estruturas
;----------------------------------------------------------------------------------------------
.const
IDC_NEWDIS1     equ 4000
                 

MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL
MAIN_EXTSTYLE    equ 300h
$ECRAWIDTH       equ 600
$ECRAHEIGHT      equ 300  
MAXSIZE          equ 260                     ; 
;  Data Section 
.data
                                
align 4
CN_ComboBoxEx   db "ComboBoxEx32",0
_ComboBoxClass  db "COMBOBOX",0
_hComboBox      dd 0
_hComboItem     dd 0
;....................................................................................
_IconName    db 'TDIcon', 0
_MenuName    db 'Menu',0        ; Definido em rsrc.rc
;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'ComboBox 1',0
;----------------------------------------
align 4
_AlteraDis  db "AlteraDis", 0
align 4
; ----------------------------------------------------------------------------------------------
_Heading1     db 'Produto', 0

_String1      db "Item 1",0
_String2      db "Item 2",0
_String3      db "Item 3",0
_String4      db "Item 4",0
_String5      db "Item five",0
_String6      db "Item six",0
_String7      db "Item seven",0

                dd 7
_TblString      dd offset _String1
                dd offset _String2
                dd offset _String3
                dd offset _String4
                dd offset _String5
                dd offset _String6
                dd offset _String7

;-----------------------------------------

szProgramName db "Subclass Combobox",0
szAboutText   db "Subclassing the edit control in a combobox",0
;  Data? Section 
.data?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_x           dd ?
_y           dd ?

_icce        INITCOMMONCONTROLSEX <?>
_hInstance   dd ?
_hWnd        dd ?
_hdc         dd ?
_CaseChoose  dd ?

_cbex        COMBOBOXEXITEM <?>
_nm          NMHDR <?>
;------------------------
_hComboEdit  dd ?
_OldEditProc dd ?
;  Code Section 
.code
;---------------------------------------
start:      invoke    GetModuleHandle, NULL
            mov       _hInstance, eax

            mov       _icce.dwSize, sizeof INITCOMMONCONTROLSEX
            mov       _icce.dwICC, ICC_USEREX_CLASSES

            invoke    InitCommonControlsEx, ADDR _icce    

            invoke    WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
            
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAWIDTH
            shr     eax, 1
            mov     _x, eax
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAHEIGHT
            shr     eax, 1
            sub     eax, 80
            mov     _y, eax

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
        	mov   _wcx.hbrBackground, COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            invoke LoadIcon, hInst, offset _IconName     
            mov    _wcx.hIcon, eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela: WS_HSCROLL or WS_VSCROLL	
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   _x, _y, $ECRAWIDTH, $ECRAHEIGHT, 
                                   NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     
            
            invoke    GetDC, _hWnd
            mov       _hdc, eax

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd           
;################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu0_1                                       

                    DIALOGBOX _AlteraDis, DlgAltDis
                                            
                case    IDM_SAIR                                       

                    invoke    SendMessage, hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND

; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
;
align 16
DlgAltDis       proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

             SWITCH  uMsg
             CASE    WM_INITDIALOG
;********************************************************

                COMBOBOX   144, 146, 160, 160, 100h
                SETUPCOMBO _TblString 

                ;Get ComboBox's Edit Control handle
                invoke ChildWindowFromPoint, _hComboBox,10,10
                mov    _hComboEdit, eax
                ;Subclass the ComboBox's Edit Control
                invoke SetWindowLong,_hComboEdit, GWL_WNDPROC, addr NewEditProc
                mov    _OldEditProc, eax

                ;invoke  SetFocus, _hComboEdit
;********************************************************
                invoke   SetDlgItemText, hWnd, IDC_NEWDIS1, addr _Heading1
                invoke   GetDlgItem, hWnd, IDC_NEWDIS1
		    invoke   SetFocus, eax
                jmp      short _Exit
                
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
             CASE    WM_CLOSE
                
_Quit:          invoke   EndDialog, hWnd, 0

_Exit:          mov     eax, TRUE
	          ret
;.............................................................
             CASE    WM_COMMAND

;------------------ComboBox--------------------------
                mov     edx, wParam
                shr     edx, 16
                switch  edx
                    ;case    CBN_SELENDOK
                        ;invoke  MessageBeep, MB_ICONHAND
                        ;invoke  MessageBeep, MB_ICONASTERISK               

                    case    CBN_SELCHANGE

                        invoke SendMessage, _hComboBox, CB_GETCURSEL, 0 ,0
                        cmp    eax, CB_ERR
                        je     short @F

                        mov    _hComboItem, eax
                        invoke  MessageBeep, MB_ICONASTERISK                        
@@:
                endsw
;------------------ComboBox-FIM-------------------------                

                switch  wParam
                    case    IDC_CANCELA
                    
                        mov     _CaseChoose, 0
                        jmp     _Quit
                                        
                    case    IDC_ALTERA
                                                                           
                        mov     _CaseChoose, 1
                        jmp     _Quit

                    case    IDC_DELETE              

                        mov     _CaseChoose, 2
                        jmp     _Quit
;.......................................................
                endsw
             ENDSW

                mov     eax, FALSE
		    ret
DlgAltDis       endp
;==========================================================================
NewEditProc     proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
switch uMsg
case    WM_CHAR
   mov eax,wParam
   .if (al >= 20h && al <= 'z') || al == VK_BACK
      invoke CallWindowProc,_OldEditProc,hWin,uMsg,wParam,lParam
      ret
   .elseif al == VK_RETURN
   
      invoke  MessageBeep, MB_ICONHAND                                 
      invoke MessageBox,_hWnd,addr szAboutText,addr szProgramName,MB_OK
      ret
   .else

      ret
   .endif

case    WM_KEYDOWN
     mov  eax,wParam
     .if al == VK_RETURN
   
      invoke  MessageBeep, MB_ICONHAND                                 
      invoke MessageBox,_hWnd,addr szAboutText,addr szProgramName,MB_OK
      ret
    .endif
endsw
   invoke CallWindowProc, _OldEditProc,hWin,uMsg,wParam,lParam
   ret

NewEditProc     endp
; ###################################################
    end     start
